Index: /XIOS/trunk/inputs/COMPLETE/iodef.xml
===================================================================
--- /XIOS/trunk/inputs/COMPLETE/iodef.xml	(revision 717)
+++ /XIOS/trunk/inputs/COMPLETE/iodef.xml	(revision 718)
@@ -10,5 +10,5 @@
         <variable_group id="buffer">
             <variable id="optimal_buffer_size" type="string">memory</variable>
-            <variable id="buffer_factor_size" type="double">1.0</variable> 
+            <variable id="buffer_size_factor" type="double">1.0</variable>
          </variable_group>
 
Index: /XIOS/trunk/inputs/REMAP/iodef.xml
===================================================================
--- /XIOS/trunk/inputs/REMAP/iodef.xml	(revision 717)
+++ /XIOS/trunk/inputs/REMAP/iodef.xml	(revision 718)
@@ -72,5 +72,5 @@
         <variable_group id="buffer">
             <variable id="optimal_buffer_size" type="string">performance</variable>
-            <variable id="buffer_factor_size" type="double">30.0</variable>
+            <variable id="buffer_size_factor" type="double">30.0</variable>
          </variable_group>
 
Index: /XIOS/trunk/inputs/Unstruct/iodef.xml
===================================================================
--- /XIOS/trunk/inputs/Unstruct/iodef.xml	(revision 717)
+++ /XIOS/trunk/inputs/Unstruct/iodef.xml	(revision 718)
@@ -35,5 +35,5 @@
         <variable_group id="buffer">
             <variable id="optimal_buffer_size" type="string">performance</variable>
-            <variable id="buffer_factor_size" type="double">1.0</variable>
+            <variable id="buffer_size_factor" type="double">1.0</variable>
          </variable_group>
 
Index: /XIOS/trunk/inputs/Version2/iodef.xml
===================================================================
--- /XIOS/trunk/inputs/Version2/iodef.xml	(revision 717)
+++ /XIOS/trunk/inputs/Version2/iodef.xml	(revision 718)
@@ -128,5 +128,5 @@
         <variable_group id="buffer">
             <variable id="optimal_buffer_size" type="string">performance</variable>
-            <variable id="buffer_factor_size" type="double">1.0</variable>
+            <variable id="buffer_size_factor" type="double">1.0</variable>
          </variable_group>
 
Index: /XIOS/trunk/inputs/iodef.xml
===================================================================
--- /XIOS/trunk/inputs/iodef.xml	(revision 717)
+++ /XIOS/trunk/inputs/iodef.xml	(revision 718)
@@ -55,5 +55,5 @@
         <variable_group id="buffer">
             <variable id="optimal_buffer_size" type="string">performance</variable>
-            <variable id="buffer_factor_size" type="double">1.0</variable>
+            <variable id="buffer_size_factor" type="double">1.0</variable>
          </variable_group>
 
Index: /XIOS/trunk/src/cxios.cpp
===================================================================
--- /XIOS/trunk/src/cxios.cpp	(revision 717)
+++ /XIOS/trunk/src/cxios.cpp	(revision 718)
@@ -24,6 +24,6 @@
   bool CXios::usingOasis ;
   bool CXios::usingServer = false;
-  double CXios::bufferServerFactorSize=1.0 ;
-  double CXios::defaultBufferServerFactorSize=1.0 ;
+  double CXios::bufferSizeFactor = 1.0;
+  const double CXios::defaultBufferSizeFactor = 1.0;
   bool CXios::printLogs2Files;
   bool CXios::isOptPerformance = true;
@@ -60,5 +60,6 @@
     }
 
-    bufferServerFactorSize=getin<double>("buffer_factor_size",defaultBufferServerFactorSize) ;
+    bufferSizeFactor = getin<double>("buffer_size_factor", defaultBufferSizeFactor);
+
     globalComm=MPI_COMM_WORLD ;
   }
Index: /XIOS/trunk/src/cxios.hpp
===================================================================
--- /XIOS/trunk/src/cxios.hpp	(revision 717)
+++ /XIOS/trunk/src/cxios.hpp	(revision 718)
@@ -40,6 +40,6 @@
      static bool usingOasis ; //!< Using Oasis
      static bool usingServer ; //!< Using server (server mode)
-     static double bufferServerFactorSize ; //!< Factor helps tune buffer size
-     static double defaultBufferServerFactorSize ; //!< Default factor value
+     static double bufferSizeFactor; //!< Factor used to tune the buffer size
+     static const double defaultBufferSizeFactor; //!< Default factor value
      static bool isOptPerformance; //!< Check if buffer size is for performance (as large as possible)
      static CRegistry* globalRegistry ; //!< global registry which is wrote by the root process of the servers
Index: /XIOS/trunk/src/node/grid.cpp
===================================================================
--- /XIOS/trunk/src/node/grid.cpp	(revision 717)
+++ /XIOS/trunk/src/node/grid.cpp	(revision 718)
@@ -86,5 +86,5 @@
    std::map<int, StdSize> CGrid::getConnectedServerDataSize()
    {
-     double secureFactor = 2.5 * sizeof(double) * CXios::bufferServerFactorSize;
+     double secureFactor = 2.5 * sizeof(double) * CXios::bufferSizeFactor;
      StdSize retVal = 1;
      std::map<int, StdSize> ret;