Index: OS/trunk/src/node/method.hpp
===================================================================
--- /XIOS/trunk/src/node/method.hpp	(revision 765)
+++ 	(revision )
@@ -1,99 +1,0 @@
-#ifndef __XIOS_CMethod__
-#define __XIOS_CMethod__
-
-namespace xios
-{
-      /// ////////////////////// DÃ©clarations ////////////////////// ///
-
-      class CMethodGroup;
-      class CMethodAttributes;
-      class CBaseMethod;
-      class CMethod;
-
-      ///--------------------------------------------------------------
-
-      // Declare/Define CMethodAttribute
-      BEGIN_DECLARE_ATTRIBUTE_MAP(CMethod)
-#include "method_attribute.conf"
-      END_DECLARE_ATTRIBUTE_MAP(CMethod)
-
-      ///--------------------------------------------------------------
-
-      class CBaseMethod
-      { // Declare CMethod functionalities
-         public :
-
-            /// Constructeur et Destructeur ///
-            CBaseMethod(void);
-            ~CBaseMethod(void);
-
-      }; // class CBaseMethod
-
-      ///--------------------------------------------------------------
-
-      class CMethod
-         : public CObjectTemplate<CMethod>
-         , public CMethodAttributes
-         , public CBaseMethod
-      {
-            /// typedef ///
-            typedef CObjectTemplate<CMethod>   SuperClass;
-            typedef CMethodAttributes SuperClassAttribute;
-            typedef CBaseMethod       SuperClassBase;
-
-         public :
-
-            typedef CMethodAttributes RelAttributes;
-            typedef CMethodGroup      RelGroup;
-
-            /// Constructeurs ///
-            CMethod(void);
-            explicit CMethod(const StdString & id);
-            CMethod(const CMethod & method);       // Not implemented yet.
-            CMethod(const CMethod * const method); // Not implemented yet.
-
-            /// Destructeur ///
-            virtual ~CMethod(void);
-
-            /// Accesseurs statiques ///
-            static inline StdString GetName(void);
-            static inline StdString GetDefName(void);
-
-      }; // class CMethod
-
-      ///--------------------------------------------------------------
-
-      // Declare/Define CMethodGroup and CMethodDefinition
-      DECLARE_GROUP(CMethod);
-
-      /// ////////////////////// DÃ©finitions ////////////////////// ///
-
-      CBaseMethod::CBaseMethod(void)
-      { /* Ne rien faire de plus */ }
-
-      CBaseMethod::~CBaseMethod(void)
-      { /* Ne rien faire de plus */ }
-
-      ///--------------------------------------------------------------
-
-      CMethod::CMethod(void)
-         : CObjectTemplate<CMethod>()
-         , CMethodAttributes()
-         , CBaseMethod()
-      { /* Ne rien faire de plus */ }
-
-      CMethod::CMethod(const StdString & id)
-         : CObjectTemplate<CMethod>(id)
-         , CMethodAttributes()
-         , CBaseMethod()
-      { /* Ne rien faire de plus */ }
-
-      CMethod::~CMethod(void)
-      { /* Ne rien faire de plus */ }
-
-      StdString CMethod::GetName(void)   { return (StdString("method")); }
-      StdString CMethod::GetDefName(void){ return (CMethod::GetName()); }
-
-} // namespace xios
-
-#endif // __XIOS_CMethod__
Index: OS/trunk/src/node/var.hpp
===================================================================
--- /XIOS/trunk/src/node/var.hpp	(revision 765)
+++ 	(revision )
@@ -1,99 +1,0 @@
-#ifndef __XIOS_CVar__
-#define __XIOS_CVar__
-
-namespace xios
-{
-      /// ////////////////////// DÃ©clarations ////////////////////// ///
-
-      class CVarGroup;
-      class CVarAttributes;
-      class CBaseVar;
-      class CVar;
-
-      ///--------------------------------------------------------------
-
-      // Declare/Define CVarAttribute
-      BEGIN_DECLARE_ATTRIBUTE_MAP(CVar)
-#include "var_attribute.conf"
-      END_DECLARE_ATTRIBUTE_MAP(CVar)
-
-      ///--------------------------------------------------------------
-
-      class CBaseVar
-      { // Declare CVar functionalities
-         public :
-
-            /// Constructeur et Destructeur ///
-            CBaseVar(void);
-            ~CBaseVar(void);
-
-      }; // class CBaseVar
-
-      ///--------------------------------------------------------------
-
-      class CVar
-         : public CObjectTemplate<CVar>
-         , public CVarAttributes
-         , public CBaseVar
-      {
-            /// typedef ///
-            typedef CObjectTemplate<CVar>   SuperClass;
-            typedef CVarAttributes SuperClassAttribute;
-            typedef CBaseVar       SuperClassBase;
-
-         public :
-
-            typedef CVarAttributes RelAttributes;
-            typedef CVarGroup      RelGroup;
-
-            /// Constructeurs ///
-            CVar(void);
-            explicit CVar(const StdString & id);
-            CVar(const CVar & var);       // Not implemented yet.
-            CVar(const CVar * const var); // Not implemented yet.
-
-            /// Destructeur ///
-            virtual ~CVar(void);
-
-            /// Accesseurs statiques ///
-            static inline StdString GetName(void);
-            static inline StdString GetDefName(void);
-
-      }; // class CVar
-
-      ///--------------------------------------------------------------
-
-      // Declare/Define CVarGroup and CVarDefinition
-      DECLARE_GROUP(CVar);
-
-      /// ////////////////////// DÃ©finitions ////////////////////// ///
-
-      CBaseVar::CBaseVar(void)
-      { /* Ne rien faire de plus */ }
-
-      CBaseVar::~CBaseVar(void)
-      { /* Ne rien faire de plus */ }
-
-      ///--------------------------------------------------------------
-
-      CVar::CVar(void)
-         : CObjectTemplate<CVar>()
-         , CVarAttributes()
-         , CBaseVar()
-      { /* Ne rien faire de plus */ }
-
-      CVar::CVar(const StdString & id)
-         : CObjectTemplate<CVar>(id)
-         , CVarAttributes()
-         , CBaseVar()
-      { /* Ne rien faire de plus */ }
-
-      CVar::~CVar(void)
-      { /* Ne rien faire de plus */ }
-
-      StdString CVar::GetName(void)   { return (StdString("var")); }
-      StdString CVar::GetDefName(void){ return (CVar::GetName()); }
-
-} // namespace xios
-
-#endif // __XIOS_CVar__