Index: /XIOS/trunk/src/io/nc4_data_output.cpp
===================================================================
--- /XIOS/trunk/src/io/nc4_data_output.cpp	(revision 771)
+++ /XIOS/trunk/src/io/nc4_data_output.cpp	(revision 772)
@@ -71,6 +71,5 @@
 
          std::vector<StdString> dim0, dim1;
-         StdString domid     = (!domain->name.isEmpty())
-                             ? domain->name.getValue() : domain->getId();
+         StdString domid = domain->getDomainOutputName();
          StdString appendDomid  = (singleDomain) ? "" : "_"+domid ;
          if (isWrittenDomain(domid)) return ;
@@ -449,6 +448,5 @@
 
          std::vector<StdString> dim0, dim1;
-         StdString domid     = (!domain->name.isEmpty())
-                             ? domain->name.getValue() : domain->getId();
+         StdString domid = domain->getDomainOutputName();
          if (isWrittenDomain(domid)) return ;
          else writtenDomains.insert(domid) ;
@@ -637,5 +635,5 @@
 
         std::vector<StdString> dims;
-        StdString axisid = !axis->name.isEmpty() ? axis->name.getValue() : axis->getId();
+        StdString axisid = axis->getAxisOutputName();
         if (isWrittenAxis(axisid)) return ;
         else writtenAxis.insert(axisid) ;
@@ -759,5 +757,5 @@
              {
                CDomain* domain = CDomain::get(domainList[domainList.size() - idxDomain - 1]);
-               StdString domId = !domain->name.isEmpty() ? domain->name.getValue() : domain->getId();
+               StdString domId = domain->getDomainOutputName();
                StdString appendDomId  = singleDomain ? "" : "_" + domId;
 
@@ -779,5 +777,5 @@
              {
                CAxis* axis = CAxis::get(axisList[axisList.size() - idxAxis - 1]);
-               compress << (!axis->name.isEmpty() ? axis->name.getValue() : axis->getId());
+               compress << axis->getAxisOutputName();
                ++idxAxis;
              }
@@ -837,5 +835,5 @@
                  continue;
 
-               StdString domId = !domain->name.isEmpty() ? domain->name.getValue() : domain->getId();
+               StdString domId = domain->getDomainOutputName();
                StdString appendDomId  = singleDomain ? "" : "_" + domId;
 
@@ -871,5 +869,5 @@
                  continue;
 
-               StdString axisId = !axis->name.isEmpty() ? axis->name.getValue() : axis->getId();
+               StdString axisId = axis->getAxisOutputName();
                varId = axisId + "_points";
                compress = axisId;
@@ -987,5 +985,5 @@
            {
              CDomain* domain = CDomain::get(domainList[idxDomain]);
-             StdString domId = !domain->name.isEmpty() ? domain->name.getValue() : domain->getId();
+             StdString domId = domain->getDomainOutputName();
              StdString appendDomId  = singleDomain ? "" : "_" + domId ;
 
@@ -1035,5 +1033,5 @@
            {
              CAxis* axis = CAxis::get(axisList[idxAxis]);
-             StdString axisId = !axis->name.isEmpty() ? axis->name.getValue() : axis->getId();
+             StdString axisId = axis->getAxisOutputName();
 
              if (compressedOutput && axis->isCompressible())
Index: /XIOS/trunk/src/node/axis.cpp
===================================================================
--- /XIOS/trunk/src/node/axis.cpp	(revision 771)
+++ /XIOS/trunk/src/node/axis.cpp	(revision 772)
@@ -891,14 +891,4 @@
       for (size_t i = 0; i < refAxis.size(); ++i)
         refAxis[i]->setTransformations(axis->getAllTransformations());
-
-    // Try to inherit the id of the referenced object as the axis name
-    // when no name was been defined and a defaut id is used.
-    if (name.isEmpty())
-    {
-      static const std::string defId("__axis_undef_id_");
-      const std::string& id = getId();
-      if (id.size() > defId.size() && id.compare(0, defId.size(), defId) == 0)
-        name = axis->getId();
-    }
   }
 
Index: /XIOS/trunk/src/node/domain.cpp
===================================================================
--- /XIOS/trunk/src/node/domain.cpp	(revision 771)
+++ /XIOS/trunk/src/node/domain.cpp	(revision 772)
@@ -1829,14 +1829,4 @@
       for (size_t i = 0; i < refDomains.size(); ++i)
         refDomains[i]->setTransformations(domain->getAllTransformations());
-
-    // Try to inherit the id of the referenced object as the domain name
-    // when no name was been defined and a defaut id is used.
-    if (name.isEmpty())
-    {
-      static const std::string defId("__domain_undef_id_");
-      const std::string& id = getId();
-      if (id.size() > defId.size() && id.compare(0, defId.size(), defId) == 0)
-        name = domain->getId();
-    }
   }
 