Index: XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90
===================================================================
--- XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 690)
+++ XIOS/trunk/src/interface/fortran_attr/idomaingroup_attr.F90	(revision 781)
@@ -13,8 +13,8 @@
   SUBROUTINE xios(set_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -33,5 +33,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_src
@@ -62,8 +61,8 @@
       CALL xios(set_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(set_domaingroup_attr)
@@ -71,8 +70,8 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -90,5 +89,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_src
@@ -118,8 +116,8 @@
       CALL xios(set_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(set_domaingroup_attr_hdl)
@@ -127,6 +125,6 @@
   SUBROUTINE xios(set_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
-    , domain_ref_, domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_ref_  &
+    , domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
     , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
     , nvertex_, standard_name_, type_ )
@@ -146,5 +144,4 @@
       INTEGER  , OPTIONAL, INTENT(IN) :: data_ni_
       INTEGER  , OPTIONAL, INTENT(IN) :: data_nj_
-      CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(IN) :: domain_src_
@@ -220,8 +217,4 @@
       ENDIF
 
-      IF (PRESENT(domain_group_ref_)) THEN
-        CALL cxios_set_domaingroup_domain_group_ref(domaingroup_hdl%daddr, domain_group_ref_, len(domain_group_ref_))
-      ENDIF
-
       IF (PRESENT(domain_ref_)) THEN
         CALL cxios_set_domaingroup_domain_ref(domaingroup_hdl%daddr, domain_ref_, len(domain_ref_))
@@ -320,8 +313,8 @@
   SUBROUTINE xios(get_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -340,5 +333,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_src
@@ -369,8 +361,8 @@
       CALL xios(get_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(get_domaingroup_attr)
@@ -378,8 +370,8 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -397,5 +389,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_src
@@ -425,8 +416,8 @@
       CALL xios(get_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(get_domaingroup_attr_hdl)
@@ -434,6 +425,6 @@
   SUBROUTINE xios(get_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
-    , domain_ref_, domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_ref_  &
+    , domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
     , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
     , nvertex_, standard_name_, type_ )
@@ -453,5 +444,4 @@
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_ni_
       INTEGER  , OPTIONAL, INTENT(OUT) :: data_nj_
-      CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_group_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_ref_
       CHARACTER(len = *) , OPTIONAL, INTENT(OUT) :: domain_src_
@@ -527,8 +517,4 @@
       ENDIF
 
-      IF (PRESENT(domain_group_ref_)) THEN
-        CALL cxios_get_domaingroup_domain_group_ref(domaingroup_hdl%daddr, domain_group_ref_, len(domain_group_ref_))
-      ENDIF
-
       IF (PRESENT(domain_ref_)) THEN
         CALL cxios_get_domaingroup_domain_ref(domaingroup_hdl%daddr, domain_ref_, len(domain_ref_))
@@ -627,8 +613,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr)  &
     ( domaingroup_id, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -659,6 +645,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj
       LOGICAL(KIND=C_BOOL) :: data_nj_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref
-      LOGICAL(KIND=C_BOOL) :: domain_group_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL(KIND=C_BOOL) :: domain_ref_tmp
@@ -709,8 +693,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)   &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(is_defined_domaingroup_attr)
@@ -718,8 +702,8 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl)  &
     ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-    , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-    , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-    , type )
+    , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+    , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+    , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+     )
 
     IMPLICIT NONE
@@ -749,6 +733,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj
       LOGICAL(KIND=C_BOOL) :: data_nj_tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref
-      LOGICAL(KIND=C_BOOL) :: domain_group_ref_tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref
       LOGICAL(KIND=C_BOOL) :: domain_ref_tmp
@@ -798,8 +780,8 @@
       CALL xios(is_defined_domaingroup_attr_hdl_)  &
       ( domaingroup_hdl, area, bounds_lat_1d, bounds_lat_2d, bounds_lon_1d, bounds_lon_2d, data_dim  &
-      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_group_ref, domain_ref  &
-      , domain_src, group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name  &
-      , lonvalue_1d, lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name  &
-      , type )
+      , data_i_index, data_ibegin, data_j_index, data_jbegin, data_ni, data_nj, domain_ref, domain_src  &
+      , group_ref, i_index, ibegin, j_index, jbegin, latvalue_1d, latvalue_2d, long_name, lonvalue_1d  &
+      , lonvalue_2d, mask_1d, mask_2d, name, ni, ni_glo, nj, nj_glo, nvertex, standard_name, type  &
+       )
 
   END SUBROUTINE xios(is_defined_domaingroup_attr_hdl)
@@ -807,6 +789,6 @@
   SUBROUTINE xios(is_defined_domaingroup_attr_hdl_)   &
     ( domaingroup_hdl, area_, bounds_lat_1d_, bounds_lat_2d_, bounds_lon_1d_, bounds_lon_2d_, data_dim_  &
-    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_group_ref_  &
-    , domain_ref_, domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
+    , data_i_index_, data_ibegin_, data_j_index_, data_jbegin_, data_ni_, data_nj_, domain_ref_  &
+    , domain_src_, group_ref_, i_index_, ibegin_, j_index_, jbegin_, latvalue_1d_, latvalue_2d_  &
     , long_name_, lonvalue_1d_, lonvalue_2d_, mask_1d_, mask_2d_, name_, ni_, ni_glo_, nj_, nj_glo_  &
     , nvertex_, standard_name_, type_ )
@@ -838,6 +820,4 @@
       LOGICAL, OPTIONAL, INTENT(OUT) :: data_nj_
       LOGICAL(KIND=C_BOOL) :: data_nj__tmp
-      LOGICAL, OPTIONAL, INTENT(OUT) :: domain_group_ref_
-      LOGICAL(KIND=C_BOOL) :: domain_group_ref__tmp
       LOGICAL, OPTIONAL, INTENT(OUT) :: domain_ref_
       LOGICAL(KIND=C_BOOL) :: domain_ref__tmp
@@ -945,9 +925,4 @@
       ENDIF
 
-      IF (PRESENT(domain_group_ref_)) THEN
-        domain_group_ref__tmp = cxios_is_defined_domaingroup_domain_group_ref(domaingroup_hdl%daddr)
-        domain_group_ref_ = domain_group_ref__tmp
-      ENDIF
-
       IF (PRESENT(domain_ref_)) THEN
         domain_ref__tmp = cxios_is_defined_domaingroup_domain_ref(domaingroup_hdl%daddr)